#include <filehdr.h>
#include <syms.h>
#include <scnhdr.h>

/* this is for linux alpha */
#include <elf.h>
#include <unistd.h>

/* this is for the DEC alpha */
/*
#include <aouthdr.h>
#include <reloc.h>
*/

#define ELF 1

/*=======================================================
=======================================================*/


/* change struct reloc here for elf */
/* 
   #define STRUCT_REL struct reloc  
 */

#define SCNHDR  Elf64_Shdr
#define FILHDR Elf64_Ehdr
#define STRUCT_REL Elf64_Rel
#define RELOC   Elf64_Rel
#define AOUTHDR Elf64_Ehdr
#define SYMBOL     Elf64_Sym
typedef long LINER, *pLINER;

/* section mapping indices that alto needs */
/* On OSF, these are defined, but they can vary in ELF */

#ifdef ELF

/* for now, simply copied out of reloc.h */
#define R_SN_NULL       0
#define R_SN_TEXT       1
#define R_SN_RDATA      2
#define R_SN_DATA       3
#define R_SN_SDATA      4
#define R_SN_SBSS       5
#define R_SN_BSS        6
#define R_SN_INIT       7
#define R_SN_GOT        8
#define R_SN_FINI   12
#define R_SN_CTORS      13
#define R_SN_DTORS      14
#define R_SN_RCONST 15
#define R_SN_SHDRSTRTAB 16
#define R_SN_SYMTAB     17
#define R_SN_STRTAB     18
#define MAX_R_SN        18
#endif


/*=======================================================
=======================================================*/

typedef struct
{
    SCNHDR scnhdr;
    union
    {
        INT8 *p8;
        INT16 *p16;
        INT32 *p32;
        INT64 *p64;
    } Data;
    INT32 nRelocs;

    RELOC *Reloc;
} STRUCT_SEC;


/*=======================================================
=======================================================*/

typedef struct
{
    FILHDR  filhdr;
    ADDRESS GlobalPointer;
    LINER      *lnt;
    char       *lss;
    char       *ess;
    SYMBOL     *symtab;
    char       *strtab;
    char       *shdrstrtab;
#if 0
    PDR        *pdt;
    NUMBER     new_text_sec_size;
#endif    
   
#ifdef COFF
    /* keeps track of which sections are where, set in binary.c */
    UINT8   SectionMap[MAX_R_SN];
#endif
#ifdef ELF
    /* in COFF, there is a max number of sections, not in ELF */
    UINT8   *SectionMap;
    Elf64_Phdr *PHDRS;
#endif
}STRUCT_BIN;

/*=======================================================
=======================================================*/

extern STRUCT_BIN    theBinary;
extern STRUCT_SEC   *aSec;

/*=======================================================
=======================================================*/

#define BIN_FILHDR            theBinary.filhdr
#define BIN_AOUTHDR           theBinary.aouthdr

/*
#define BIN_NEW_TEXT_SEC_SIZE theBinary.new_text_sec_size
*/

/* a.out stuff */
#ifdef COFF
#define BIN_HDRR              theBinary.hdrr
#define BIN_NSECTIONS         theBinary.filhdr.f_nscns
#define BIN_ENTRY             theBinary.aouthdr.entry
#define BIN_GP                theBinary.aouthdr.gp_value
#define BIN_SECTION_MAP       theBinary.SectionMap
#endif

/* elf stuff */
#ifdef ELF
#define BIN_GP                theBinary.GlobalPointer
#define BIN_HDRR              theBinary.hdrr
#define BIN_NSECTIONS         theBinary.filhdr.e_shnum
#define BIN_SECTION_MAP       theBinary.SectionMap
#define BIN_ENTRY             theBinary.filhdr.e_entry
#define BIN_SYMBOL_TAB        ((Elf64_Sym *)(ASEC_DATA8(theBinary.SectionMap[R_SN_SYMTAB])))
#define BIN_SHDRSTRTAB        theBinary.shdrstrtab
#define BIN_SYMBOL_NENT       ASEC(theBinary.SectionMap[R_SN_SYMTAB]).scnhdr.sh_size/ASEC(theBinary.SectionMap[R_SN_SYMTAB]).scnhdr.sh_entsize
#define BIN_STRING_TAB        theBinary.strtab
#define SYM_ADDRESS(i)        BIN_SYMBOL_TAB[i].st_value
#endif


#define BIN_SYMBOL_NPDT       theBinary.hdrr.ipdMax
#define BIN_SYMBOL_NLST       theBinary.hdrr.isymMax
#define BIN_SYMBOL_NLSS       theBinary.hdrr.issMax
#define BIN_SYMBOL_NFDT       theBinary.hdrr.ifdMax
#define BIN_SYMBOL_NEST       theBinary.hdrr.iextMax
#define BIN_SYMBOL_NESS       theBinary.hdrr.issExtMax

#define BIN_SYMBOL_PDT        theBinary.pdt
#define BIN_SYMBOL_LST        theBinary.lst
#define BIN_SYMBOL_LSS        theBinary.lss
#define BIN_SYMBOL_FDT        theBinary.fdt
#define BIN_SYMBOL_ESS        theBinary.ess
#define BIN_SYMBOL_EST        theBinary.est

/*=======================================================
=======================================================*/

#define IS_STYP_REG(flags)      ((flags & 0xf) == STYP_REG)
#define IS_STYP_DSECT(flags)    ((flags & 0xf) == STYP_DSECT)
#define IS_STYP_NOLOAD(flags)   ((flags & 0xf) == STYP_NOLOAD)
#define IS_STYP_GROUP(flags)    ((flags & 0xf) == STYP_GROUP)
#define IS_STYP_PAD(flags)      ((flags & 0xf) == STYP_PAD)

#define IS_STYP_COPY(flags)     (flags & STYP_COPY)
#define IS_STYP_TEXT(flags)     ((flags & SHF_EXECINSTR)&&(flags & SHF_ALLOC))
#define IS_STYP_DATA(flags)     (flags & STYP_DATA)
#define IS_STYP_BSS(flags)      (flags & STYP_BSS)

#define IS_STYP_RDATA(flags)    (flags & STYP_RDATA)
#define IS_STYP_SDATA(flags)    (flags & STYP_SDATA)
#define IS_STYP_SBSS(flags)     (flags & STYP_SBSS)
#define IS_STYP_UCODE(flags)    (flags & STYP_UCODE)

#define IS_STYP_GOT(flags)      (flags & STYP_GOT)
#define IS_STYP_DYNAMIC(flags)  (flags & STYP_DYNAMIC)
#define IS_STYP_DYNSYM(flags)   (flags & STYP_DYNSYM)
#define IS_STYP_REL_DYN(flags)  (flags & STYP_REL_DYN)
#define IS_STYP_DYNSTR(flags)   (flags & STYP_DYNSTR)
#define IS_STYP_HASH(flags)     (flags & STYP_HASH)

#define IS_STYP_EXTENDESC(flags) (flags & STYP_EXTENDESC)

#define IS_STYP_CONFLICT(flags) (!IS_STYP_EXTENDESC(flags) && (flags & STYP_CONFLICT))
#define IS_STYP_REGINFO(flags)  (!IS_STYP_EXTENDESC(flags) && (flags & STYP_REGINFO))

#define IS_STYP_LITA(flags)     (flags & STYP_LITA)
#define IS_STYP_LIT8(flags)     (flags & STYP_LIT8)
#define IS_STYP_LIT4(flags)     (flags & STYP_LIT4)
#define IS_S_NRELOC_OVFL(flags) (flags & S_NRELOC_OVFL)     
#define IS_STYP_LIB(flags)      (flags & STYP_LIB)
#define IS_STYP_INIT(flags)     (flags & STYP_INIT)
#define IS_STYP_FINI(flags)     (flags & STYP_FINI)

#define IS_STYP_COMMENT(flags)  ((flags & STYP_EXTMASK) == STYP_COMMENT)
#define IS_STYP_RCONST(flags)   ((flags & STYP_EXTMASK) == STYP_RCONST)
#define IS_STYP_XDATA(flags)    ((flags & STYP_EXTMASK) == STYP_XDATA)
#define IS_STYP_PDATA(flags)    ((flags & STYP_EXTMASK) == STYP_PDATA)

/*=======================================================
=======================================================*/

#define APDR_ADDRESS(ip) Global.theBinary.pdt[ip].adr

/*=======================================================
=======================================================*/

#define ALSY(is)         BIN_SYMBOL_LST[is]
#define ALSY_VALUE(i)    ALSY(i).value
#define ALSY_NAME(i)     (BIN_SYMBOL_LSS + ALSY(i).iss)
#define ALSY_TYPE(i)     ALSY(i).st
#define ALSY_IS_PROC(i)  (ALSY_TYPE(i)==stProc || ALSY_TYPE(i)==stStaticProc)
#define FOREACH_LSY(i)  for(i=0; i < BIN_SYMBOL_NLST; i++ )

#define AESY(is)         BIN_SYMBOL_EST[is].asym
#define AESY_VALUE(i)    AESY(i).value
#define AESY_NAME(i)     (BIN_SYMBOL_ESS + AESY(i).iss)
#define AESY_TYPE(i)     AESY(i).st
#define AESY_IS_PROC(i)  (AESY_TYPE(i)==stProc || AESY_TYPE(i)==stStaticProc)
#define FOREACH_ESY(i)   for(i=0; i < BIN_SYMBOL_NEST; i++ )

#define SYM(i)           BIN_SYMBOL_TAB[i]
#define FOREACH_SYM(i)   for (i=0; i < BIN_SYMBOL_NENT; i++)
#define SYM_NAME(i)      BIN_STRING_TAB + SYM(i).st_name
#define SYM_IS_PROC(s)   (ELF64_ST_TYPE(s->st_info) == STT_FUNC)
#define SYM_VALUE(i)     SYM(i).st_value

/*=======================================================
=======================================================*/

#define APDR(ip)        theBinary.pdt[ip]
#define AFDR(if)        theBinary.fdt[if]

/*=======================================================
=======================================================*/
#define ASEC(i)         aSec[i]

#define ASEC_SCNHDR(i)  ASEC(i).scnhdr
#define ASEC_SIZE(i)    ASEC(i).scnhdr.sh_size
#define ASEC_START(i)   ASEC(i).scnhdr.sh_addr
#define ASEC_NRELOCS(i) ASEC(i).nRelocs
#define ASEC_RELOC(i)   ASEC(i).Reloc
#define ASEC_DATA8(i)   ASEC(i).Data.p8
#define ASEC_DATA16(i)  ASEC(i).Data.p16
#define ASEC_DATA32(i)  ASEC(i).Data.p32
#define ASEC_DATA64(i)  ASEC(i).Data.p64

/* MUCH more complicated in elf */
#define ASEC_NAME(i)    ASEC(i).scnhdr.sh_name 

#define ASEC_FLAGS(i)   ASEC(i).scnhdr.sh_flags

#ifdef COFF     

#define ASEC_IS_TEXT(i)  IS_STYP_TEXT(ASEC_FLAGS(i))
#define ASEC_IS_RDATA(i) IS_STYP_RDATA(ASEC_FLAGS(i))
#define ASEC_IS_DATA(i)  IS_STYP_DATA(ASEC_FLAGS(i))
#define ASEC_IS_SDATA(i) IS_STYP_SDATA(ASEC_FLAGS(i))
#define ASEC_IS_BSS(i)   IS_STYP_BSS(ASEC_FLAGS(i))
#define ASEC_IS_SBSS(i)  IS_STYP_SBSS(ASEC_FLAGS(i))
#define ASEC_IS_INIT(i)  IS_STYP_INIT(ASEC_FLAGS(i))
#define ASEC_IS_LIT8(i)  IS_STYP_LIT8(ASEC_FLAGS(i))
#define ASEC_IS_LIT4(i)  IS_STYP_LIT4(ASEC_FLAGS(i))
#define ASEC_IS_XDATA(i) IS_STYP_XDATA(ASEC_FLAGS(i))
#define ASEC_IS_PDATA(i) IS_STYP_PDATA(ASEC_FLAGS(i))
#define ASEC_IS_FINI(i)  IS_STYP_FINI(ASEC_FLAGS(i))
#define ASEC_IS_LITA(i)  IS_STYP_LITA(ASEC_FLAGS(i))
#define ASEC_IS_RCONST(i) IS_STYP_RCONST(ASEC_FLAGS(i))
#define ASEC_IS_SHDRSTRTAB(i) (i == theBinary.filhdr.e_shstrndx)
#define ASEC_AREL_TYPE(is,ir)    ASEC_AREL(is,ir).r_type
#define ASEC_AREL(is,ir)         ASEC(is).Reloc[ir]
#define ASEC_AREL_EXTERN(is,ir)  ASEC_AREL(is,ir).r_extern
#define ASEC_AREL_SECTION(is,ir) (ASEC_AREL(is,ir).r_symndx & 0xf)
#define ASEC_AREL_ADDRESS(is,ir) ASEC_AREL(is,ir).r_vaddr
#define ASEC_AREL_SYMBOL(is,ir)  ASEC_AREL(is,ir).r_symndx
#define ASEC_AREL_OFFSET(is,ir)  ASEC_AREL(is,ir).r_offset
#define ASEC_AREL_SIZE(is,ir)    ASEC_AREL(is,ir).r_size
#endif

#ifdef ELF
#define ASEC_IS_NULL(i)  (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".null") == 0)
#define ASEC_IS_TEXT(i)  (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".text") == 0)
#define ASEC_IS_RDATA(i) (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".rodata")==0)
#define ASEC_IS_DATA(i)  (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".data")==0)
#define ASEC_IS_GOT(i)  (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".got") == 0)
#define ASEC_IS_SDATA(i) 0 /* no sdata in ELF */
#define ASEC_IS_BSS(i)   (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".bss")==0)
#define ASEC_IS_SBSS(i)  0 /* no sbss in ELF */
#define ASEC_IS_INIT(i)  (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".init")==0)
#define ASEC_IS_LIT8(i)  0 /* no lit8 in ELF */
#define ASEC_IS_LIT4(i)  0 /* no lit4 in ELF */
#define ASEC_IS_XDATA(i) 0 /* no Xdata in ELF */
#define ASEC_IS_PDATA(i) 0 /* no Pdata in ELF */
#define ASEC_IS_FINI(i)  (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".fini")==0)
#define ASEC_IS_LITA(i)  0 /* no LITA in ELF */
#define ASEC_IS_RCONST(i) 0 /* no RConst in ELF */
#define ASEC_IS_STRTAB(i) (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".strtab")==0)
#define ASEC_IS_SYMTAB(i) (strcmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".symtab")==0)
#define ASEC_IS_SHDRSTRTAB(i) (i == theBinary.filhdr.e_shstrndx)
#define ASEC_INFO(i) ASEC_SCNHDR(i).sh_info

/* relocation info */
#define ASEC_IS_REL(i) (strncmp(&BIN_SHDRSTRTAB[ASEC_NAME(i)],".rel", 4)==0)


/* we've got both rel and rela (rela's have an addend) */
#define ASEC_AREL(is, ir)        ((Elf64_Rel *)ASEC_DATA8(is))[ir]
#define ASEC_AREL_TYPE(is,ir)    ELF64_R_TYPE(ASEC_AREL(is,ir).r_info)
#define ASEC_AREL_ADDRESS(is,ir)  ASEC_AREL(is,ir).r_offset
/* if it's an executable, the vaddr is the offset */
#define ASEC_AREL_OFFSET(is,ir)   ASEC_AREL(is,ir).r_offset
#define ASEC_AREL_SYMBOL(is,ir)  ELF64_R_SYM(ASEC_AREL(is,ir).r_info)

#define ASEC_ARELA(is, ir)        ((Elf64_Rela *)ASEC_DATA8(is))[ir]
#define ASEC_ARELA_TYPE(is,ir)   ELF64_R_TYPE(ASEC_ARELA(is,ir).r_info)
#define ASEC_ARELA_ADDRESS(is,ir) ASEC_ARELA(is,ir).r_offset
#define ASEC_ARELA_ADDEND(is,ir) ASEC_ARELA(is,ir).r_addend
#define ASEC_ARELA_OFFSET(is,ir)  ASEC_AREL(is,ir).r_offset
#define ASEC_ARELA_SYMBOL(is,ir)  ELF64_R_SYM(ASEC_ARELA(is,ir).r_info)
#endif

#define ASEC_HAS_RELOC_OVFL(i) IS_S_NRELOC_OVFL(ASEC_FLAGS(i))



